Index: branches/UKMO/AMM15_v3_6_STABLE_package_reanalysis3/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_reanalysis3/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 11066)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_reanalysis3/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 11085)
@@ -160,4 +160,6 @@
      INTEGER           ::   ios,jsec        ! Local integer output status for namelist read
      CHARACTER(len=3)  ::   jsec_str        ! name of the jsec
+     LOGICAL       ::   verbose     
+     verbose = .false.
 
      IF( nn_timing == 1 )   CALL timing_start('dia_dct_init')
@@ -204,4 +206,5 @@
 
      IF( lwp ) THEN
+       IF( verbose ) THEN
         WRITE(numout,*) " "
         WRITE(numout,*) "diadct_init: compute transports through sections "
@@ -223,4 +226,5 @@
            WRITE(numout,*) "       Frequency of write:       nn_dctwri = ",nn_dctwri
         ENDIF
+       ENDIF
 
         IF      ( nn_secdebug .GE. 1 .AND. nn_secdebug .LE. nb_sec_max )THEN
@@ -254,7 +258,7 @@
            ENDIF
         ELSE
-           CALL ctl_opn( numdct_vol,  'volume_transport', 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
-           CALL ctl_opn( numdct_heat, 'heat_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
-           CALL ctl_opn( numdct_salt, 'salt_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_vol,  'volume_transport', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_heat, 'heat_transport'  , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_salt, 'salt_transport'  , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
         ENDIF
      ENDIF
@@ -357,4 +361,6 @@
      REAL(wp), POINTER, DIMENSION(:)    :: zwork !   "  
      REAL(wp), POINTER, DIMENSION(:,:,:):: zsum  !   "
+     LOGICAL       ::   verbose     
+     verbose = .false.
 
      !!---------------------------------------------------------------------    
@@ -371,5 +377,5 @@
      zsum(:,:,:) = 0.0
 
-     IF( lwp .AND. kt==nit000+nn_dct-1 ) THEN
+     IF( lwp .AND. kt==nit000+nn_dct-1 .AND. verbose ) THEN
          WRITE(numout,*) " "
          WRITE(numout,*) "diadct: compute transport"
@@ -408,5 +414,5 @@
             
 
-              IF( lwp .AND. kt==nit000+nn_dctwri-1 ) WRITE(numout,*)"      diadct: average and write at kt = ",kt
+              IF( lwp .AND. kt==nit000+nn_dctwri-1 .AND. verbose ) WRITE(numout,*)"      diadct: average and write at kt = ",kt
 
 
@@ -473,5 +479,5 @@
             IF( MOD(kt,nn_dctwri_h)==0 )THEN
 
-              IF( lwp .AND. kt==nit000+nn_dctwri_h-1 )WRITE(numout,*)"      diadct: average and write hourly files at kt = ",kt         
+              IF( lwp .AND. kt==nit000+nn_dctwri_h-1 .AND. verbose )WRITE(numout,*)"      diadct: average and write hourly files at kt = ",kt         
       
               !! divide arrays by nn_dctwri/nn_dct to obtain average
@@ -556,4 +562,6 @@
      LOGICAL :: llbon                                       ,&!local logical
                 lldebug                                       !debug the section
+     LOGICAL       ::   verbose     
+     verbose = .false.
      !!-------------------------------------------------------------------------------------
      CALL wrk_alloc( nb_point_max, directemp )
@@ -564,5 +572,5 @@
      !OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='LITTLE_ENDIAN')
      
-     write(numout,*) 'dct low-level pre open: big endian :',nproc,narea
+     IF ( verbose ) write(numout,*) 'dct low-level pre open: big endian :',nproc,narea
      OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='BIG_ENDIAN')
      
@@ -632,5 +640,5 @@
         READ(numdct_in)iptglo
 
-        IF ( ln_NOOS ) THEN
+        IF ( ln_NOOS .AND. verbose ) THEN
            WRITE(numout,*) 'Section name = ',TRIM(secs(jsec)%name)
            WRITE(numout,*) 'coordSec = ',secs(jsec)%coordSec
@@ -663,5 +671,5 @@
            !read points'coordinates and directions 
            !--------------------------------------
-           IF ( ln_NOOS ) THEN
+           IF ( ln_NOOS .AND. verbose ) THEN
               WRITE(numout,*) 'Coords and direction read'
            ENDIF
@@ -766,5 +774,5 @@
      nb_sec = jsec-1   !number of section read in the file
 
-     IF( lwp )  WRITE(numout,*)'diadct: read sections: Finished readsec.'
+     IF( lwp .AND. verbose )  WRITE(numout,*)'diadct: read sections: Finished readsec.'
 
      CALL wrk_dealloc( nb_point_max, directemp )
@@ -1823,4 +1831,6 @@
      REAL(wp), DIMENSION(3) :: tmp_iom_output
      REAL(wp)               :: max_iom_val
+     LOGICAL       ::   verbose     
+     verbose = .false.
      
      !!------------------------------------------------------------- 
@@ -1828,5 +1838,5 @@
      
      
-     IF( lwp ) THEN
+     IF( lwp .AND. verbose ) THEN
         WRITE(numout,*) " "
         WRITE(numout,*) "dia_dct_wri_NOOS: write transports through sections at timestep: ", kt
@@ -2176,5 +2186,5 @@
          
          noos_var_sect_name = "noos_" // trim(noos_sect_name) // '_trans'
-         if ( lwp ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
+         if ( lwp .AND. verbose ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
          CALL iom_put( noos_var_sect_name,  noos_iom_dummy )
          noos_iom_dummy(:,:,:) = 0.
@@ -2212,5 +2222,5 @@
          
          noos_var_sect_name =  "noos_" // trim(noos_sect_name) // '_heat'
-         if ( lwp ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
+         if ( lwp .AND. verbose ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
          CALL iom_put(noos_var_sect_name,  noos_iom_dummy )  
          noos_iom_dummy(:,:,:) = 0.
@@ -2249,5 +2259,5 @@
          
          noos_var_sect_name = "noos_" // trim(noos_sect_name) // '_salt'
-         if ( lwp ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
+         if ( lwp .AND. verbose ) WRITE(numout,*) 'dia_dct_wri_NOOS iom_put: ', kt,ksec, noos_var_sect_name
          CALL iom_put(noos_var_sect_name,  noos_iom_dummy )
          noos_iom_dummy(:,:,:) = 0.         
@@ -2361,8 +2371,10 @@
      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   noos_iom_dummy
      INTEGER               :: IERR
+     LOGICAL       ::   verbose     
+     verbose = .false.
      
      !!------------------------------------------------------------- 
 
-     IF( lwp ) THEN
+     IF( lwp .AND. verbose ) THEN
         WRITE(numout,*) " "
         WRITE(numout,*) "dia_dct_wri_NOOS_h: write transports through section Transect:",ksec-1," at timestep: ", hr